#!/bin/bash

function is_integer() {
	[ "$1" -eq "$1" ] > /dev/null 2>&1
	return $?
}

echo -e "\nЭтот скрипт запустит программу несколько раз,"
echo "в соответствии с задаными параметрами."

echo -e "\nДлина сообщения (1 и более): \c"
read msg_len

if ! is_integer $msg_len # "$msg_len" -eq "$msg_len" 2> /dev/null
then
	echo "    Неверный ввод"
	exit
fi

if [ $msg_len -lt 1 ]
then
	echo "    Длина сообщения дб не меньше 1"
	exit 
fi

echo -e "\nНачальное количество процессов (np > 2): \c"
read start_np

if ! is_integer $start_np
then
	echo "    Неверный ввод"
	exit
fi

if [ $start_np -lt 2 ]
then
	echo "    np должно быть больше двух"
	exit 
fi

echo -e "\nМаксимальное количество процессов (max np): \c"
read max_np

if ! is_integer $max_np
then
	echo "    Неверный ввод"
	exit
fi

if [ $max_np -lt $start_np ]
then
	echo "    Макс np дб больше стартового np"
	exit 
fi

echo -e "\nШаг увеличения числа процессов (np += step): \c"
read np_step

if ! is_integer $np_step
then
	echo "    Неверный ввод"
	exit
fi

let np_diff=$max_np-$start_np
if [ $np_step -gt $np_diff ]
then
	echo "    Неверное значение"
	exit 
fi

echo -e "\nНазвание файла программы: (по умолчанию main.f90): \c"

read prog_name
length=${#prog_name}
if [ $length -eq 0 ]
then
	prog_name="main.f90"
fi

executable_name="a.out"
echo "Компиляция mpif90 $prog_name..."
mpif90 $prog_name

np=$start_np
until [ $np -gt $max_np ]; do
	echo "Запуск: mpirun -np $np a.out $msg_len..."
	mpirun -np $np $executable_name $msg_len
	let np+=$np_step
done

