! Самостоятельная работа, Кремер Илья | http://kremer.pro/blog/?post_type=post&p=75

program main
	implicit none
	include "mpif.h"
	integer ierr, pid, np, status(MPI_STATUS_SIZE)
	integer next, prev
	character(len=10) :: arg_n
	integer msg_size ! msg size
	integer, parameter :: MSG_DEFAULT_SIZE = 10000
	integer, allocatable, dimension (:) :: a ! msg
	double precision start

	call mpi_init(ierr)
	call mpi_comm_rank(MPI_COMM_WORLD, pid, ierr)
	call mpi_comm_size(MPI_COMM_WORLD, np,  ierr)

	if (np == 1) then
		print *, "BAD NP"
		call mpi_finalize(ierr)
		stop
	endif

	if (iargc() == 0) then
		msg_size = MSG_DEFAULT_SIZE
	else
		call getarg(1, arg_n)
		read (arg_n, '(i7)') msg_size
		if (msg_size <= 1) then
			if (pid == 0) print *, "Неверно задана длина сообщения"
			call mpi_finalize(ierr)
			stop
		endif
	endif

	allocate(a(msg_size))
	a = 0
	if (pid == 0) then
		print '(a, i7)', "Длина сообщения:", msg_size
		start = mpi_wtime()
		call mpi_send(a, msg_size, MPI_INTEGER, 1,      5, MPI_COMM_WORLD, ierr)
		call mpi_recv(a, msg_size, MPI_INTEGER, np - 1, 5, MPI_COMM_WORLD, status, ierr)
		! вывод сообщения
		print '(a, f12.8, a)', "затрачено ", mpi_wtime() - start, "   сек"
	else if (pid == np - 1) then
		next = 0
		prev = pid - 1
	else
		next = pid + 1
		prev = pid - 1
	endif

	if (pid /= 0) then
		call mpi_recv(a, msg_size, MPI_INTEGER, prev, 5, MPI_COMM_WORLD, status, ierr)
		! какое-то изменение сообщения
		call mpi_send(a, msg_size, MPI_INTEGER, next, 5, MPI_COMM_WORLD, ierr)
	endif

	call mpi_finalize(ierr)
end program

